
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: No
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rx_wr_index=R5
	.DEF _read_enable=R4
	.DEF _rx_counter=R7
	.DEF _rx_buffer_overflow=R6
	.DEF _i=R9
	.DEF _last_error=R10
	.DEF _last_error_msb=R11
	.DEF _flow_max=R12
	.DEF _flow_max_msb=R13
	.DEF _flag_pid_on=R8

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP _usart_rx
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0

_0x3:
	.DB  0x0,0x0,0x0,0x3F
_0x4:
	.DB  0x9A,0x99,0x19,0x3E
_0x5:
	.DB  0x6F,0x12,0x83,0x3A
_0x6:
	.DB  0x9A,0x99,0xD9,0x3F
_0x7:
	.DB  0x2
_0x0:
	.DB  0x24,0x0,0x20,0x0,0x3B,0x0,0x70,0x72
	.DB  0x69,0x6D,0x61,0x72,0x79,0x5F,0x76,0x61
	.DB  0x6C,0x75,0x65,0x73,0x0,0x66,0x6C,0x6F
	.DB  0x77,0x5F,0x6D,0x69,0x6E,0x20,0x0,0x61
	.DB  0x0,0x66,0x6C,0x6F,0x77,0x5F,0x6D,0x61
	.DB  0x78,0x20,0x0,0x62,0x0,0x74,0x65,0x6D
	.DB  0x70,0x65,0x72,0x5F,0x6D,0x69,0x6E,0x20
	.DB  0x0,0x63,0x0,0x74,0x65,0x6D,0x70,0x65
	.DB  0x72,0x5F,0x6D,0x61,0x78,0x20,0x0,0x64
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x04
	.DW  __REG_VARS*2

	.DW  0x04
	.DW  _Kp
	.DW  _0x4*2

	.DW  0x04
	.DW  _Ki
	.DW  _0x5*2

	.DW  0x04
	.DW  _Kd
	.DW  _0x6*2

	.DW  0x01
	.DW  _buzzer_flag
	.DW  _0x7*2

	.DW  0x02
	.DW  _0x23
	.DW  _0x0*2

	.DW  0x02
	.DW  _0x23+2
	.DW  _0x0*2+2

	.DW  0x02
	.DW  _0x23+4
	.DW  _0x0*2+2

	.DW  0x02
	.DW  _0x23+6
	.DW  _0x0*2+4

	.DW  0x0F
	.DW  _0x23+8
	.DW  _0x0*2+6

	.DW  0x0A
	.DW  _0x23+23
	.DW  _0x0*2+21

	.DW  0x02
	.DW  _0x23+33
	.DW  _0x0*2+31

	.DW  0x0A
	.DW  _0x23+35
	.DW  _0x0*2+33

	.DW  0x02
	.DW  _0x23+45
	.DW  _0x0*2+43

	.DW  0x0C
	.DW  _0x23+47
	.DW  _0x0*2+45

	.DW  0x02
	.DW  _0x23+59
	.DW  _0x0*2+57

	.DW  0x0C
	.DW  _0x23+61
	.DW  _0x0*2+59

	.DW  0x02
	.DW  _0x23+73
	.DW  _0x0*2+71

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*
; * dryer_station.c
; *
; * Created: 22.11.2017 16:12:58
; * Author: Artem
; */
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;
;
;#define relay_on PORTD |= (1<<PORTD5)
;#define relay_off PORTD &= ~(1<<PORTD5)
;#define power_on !PINB.0
;#define power_off PINB.0
;#define triac_on PORTB |= (1<<PORTB1)
;#define triac_off PORTB &= ~(1<<PORTB1)
;#define reed_switch_on PIND.7
;#define reed_switch_off !PIND.7
;#define led_red_on PORTC |= (1<<PORTC2)
;#define led_red_off PORTC &= ~(1<<PORTC2)
;#define led_green_on PORTC |= (1<<PORTC1)
;#define led_green_off PORTC &= ~(1<<PORTC1)
;#define buzzer_on PORTD |= (1<<PORTD6)
;#define buzzer_off PORTD &= ~(1<<PORTD6)
;
;
;
;
;
;
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<DOR)
;
;// USART Receiver buffer
;#define RX_BUFFER_SIZE 5
;unsigned long int rx_buffer[RX_BUFFER_SIZE];    //5
;unsigned char rx_wr_index;
;char read_enable = 0;
;volatile char parameters_out = 0;
;unsigned char rx_counter;
;char rx_buffer_overflow;
;
;
;// Standard Input/Output functions
;#include <stdio.h>
;
;
;
;
;
;
;// Declare your global variables here
;    volatile unsigned char flag_phase;
;    volatile unsigned char flag_100hz;
;     volatile unsigned int temper;
;             unsigned char i;     //  
;     volatile unsigned int set_temper;
;volatile unsigned long int set_temper_adc_aver;
;     volatile unsigned int set_temper_aver;
;     volatile unsigned int last_set_temper_aver;
;               float const coefLPF = 0.5;

	.DSEG
;
;       volatile signed int error;
;           signed long int integral;
;
;                     float Kp=0.15;      //0.15
;
;                     float Ki=0.001;    // 0.0001
;
;                     float Kd=1.7;       //1.5
;
;       volatile signed int control_action;
;                signed int last_error;
;       volatile signed int sp;
;volatile unsigned long int set_flow_aver;
;     volatile unsigned int set_flow;
;     volatile unsigned int flow;
;     volatile unsigned int last_flow;
;     volatile unsigned int flow_min;
;              unsigned int flow_max;
;              unsigned int temper_min;
;              unsigned int temper_max;
;             unsigned char flag_pid_on;
;             unsigned char buzzer_flag = 2;
;             unsigned char buzzer_time = 0;
;             unsigned char flag_flow_adj;
;     volatile unsigned int reed_switch_time = 0;
;
;    volatile unsigned char led_pwm_off;
;    volatile unsigned char led_pwm_on;
;    volatile unsigned char led_pwm_flag;
;    volatile unsigned char sleep_on;
;    volatile unsigned char standby_on;
;    volatile unsigned char NewState;
;    volatile unsigned char OldState;
;
;
;              //EEPROM
;unsigned int eeprom eeflow_min;
;unsigned int eeprom eeflow_max;
;unsigned int eeprom eetemper_min;
;unsigned int eeprom eetemper_max;
;unsigned char eeprom eeflag_primary_values;
;
;
;//    UART
;void send_Uart(unsigned char c)//    
; 0000 0071    {

	.CSEG
_send_Uart:
; .FSTART _send_Uart
; 0000 0072    while(!(UCSRA&(1<<UDRE)))    //  ,   
	ST   -Y,R26
;	c -> Y+0
_0x8:
	SBIS 0xB,5
; 0000 0073     {}
	RJMP _0x8
; 0000 0074     UDR = c;
	LD   R30,Y
	OUT  0xC,R30
; 0000 0075    }
	ADIW R28,1
	RET
; .FEND
;
; void send_int_Uart(unsigned int c)//       0000  9999
; 0000 0078   {
_send_int_Uart:
; .FSTART _send_int_Uart
; 0000 0079   unsigned char temp;                           //=2013
; 0000 007A   c=c%10000;                                    //  2013%10000    0
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	c -> Y+1
;	temp -> R17
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	RCALL __MODW21U
	STD  Y+1,R30
	STD  Y+1+1,R31
; 0000 007B   temp=c/100;                                   // 2013/100=  20
	RCALL SUBOPT_0x0
	RCALL __DIVW21U
	MOV  R17,R30
; 0000 007C   //send_Uart(temp/10+'0');                       //  20/10 = 2 +'0'
; 0000 007D   send_Uart(temp%10+'0');                       // 20%10 = 0 +'0'
	RCALL SUBOPT_0x1
; 0000 007E   temp=c%100;;                                  // 2013%100 = 13
	RCALL SUBOPT_0x0
	RCALL __MODW21U
	MOV  R17,R30
; 0000 007F   send_Uart(temp/10+'0');                       // 13/10 = 1+'0'
	MOV  R26,R17
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	SUBI R30,-LOW(48)
	MOV  R26,R30
	RCALL _send_Uart
; 0000 0080   send_Uart(temp%10+'0');                       // 13%10 = 3+'0'
	RCALL SUBOPT_0x1
; 0000 0081   }
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
;
;void send_Uart_str(unsigned char *s)//	 
; 0000 0084   {
_send_Uart_str:
; .FSTART _send_Uart_str
; 0000 0085    while (*s != 0) send_Uart(*s++);
	ST   -Y,R27
	ST   -Y,R26
;	*s -> Y+0
_0xB:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0xD
	LD   R30,X+
	ST   Y,R26
	STD  Y+1,R27
	MOV  R26,R30
	RCALL _send_Uart
	RJMP _0xB
_0xD:
; 0000 0086 }
	ADIW R28,2
	RET
; .FEND
;
;
;
;
;
;
;void main(void)
; 0000 008E {
_main:
; .FSTART _main
; 0000 008F 
; 0000 0090 //   
; 0000 0091 if(eeflag_primary_values == 255)
	LDI  R26,LOW(_eeflag_primary_values)
	LDI  R27,HIGH(_eeflag_primary_values)
	RCALL __EEPROMRDB
	CPI  R30,LOW(0xFF)
	BRNE _0xE
; 0000 0092  {
; 0000 0093  eeflow_min = 80;
	LDI  R26,LOW(_eeflow_min)
	LDI  R27,HIGH(_eeflow_min)
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	RCALL __EEPROMWRW
; 0000 0094  eeflow_max = 254;
	LDI  R26,LOW(_eeflow_max)
	LDI  R27,HIGH(_eeflow_max)
	LDI  R30,LOW(254)
	LDI  R31,HIGH(254)
	RCALL __EEPROMWRW
; 0000 0095  eetemper_min = 50;
	LDI  R26,LOW(_eetemper_min)
	LDI  R27,HIGH(_eetemper_min)
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __EEPROMWRW
; 0000 0096  eetemper_max = 450;
	LDI  R26,LOW(_eetemper_max)
	LDI  R27,HIGH(_eetemper_max)
	LDI  R30,LOW(450)
	LDI  R31,HIGH(450)
	RCALL __EEPROMWRW
; 0000 0097  eeflag_primary_values = 0;
	LDI  R26,LOW(_eeflag_primary_values)
	LDI  R27,HIGH(_eeflag_primary_values)
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
; 0000 0098  }
; 0000 0099 
; 0000 009A 
; 0000 009B 
; 0000 009C 
; 0000 009D //   eeprom
; 0000 009E flow_min = eeflow_min;
_0xE:
	LDI  R26,LOW(_eeflow_min)
	LDI  R27,HIGH(_eeflow_min)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x2
; 0000 009F flow_max = eeflow_max;
	LDI  R26,LOW(_eeflow_max)
	LDI  R27,HIGH(_eeflow_max)
	RCALL __EEPROMRDW
	MOVW R12,R30
; 0000 00A0 temper_min = eetemper_min;
	LDI  R26,LOW(_eetemper_min)
	LDI  R27,HIGH(_eetemper_min)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x3
; 0000 00A1 temper_max = eetemper_max;
	LDI  R26,LOW(_eetemper_max)
	LDI  R27,HIGH(_eetemper_max)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x4
; 0000 00A2 
; 0000 00A3 
; 0000 00A4 
; 0000 00A5 
; 0000 00A6 // Declare your local variables here
; 0000 00A7 
; 0000 00A8 // Input/Output Ports initialization
; 0000 00A9 // Port B initialization
; 0000 00AA // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=Out Bit2=In Bit1=In Bit0=In
; 0000 00AB DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (1<<DDB3) | (0<<DDB2) | (1<<DDB1) | (0<<DDB0);
	LDI  R30,LOW(10)
	OUT  0x17,R30
; 0000 00AC // State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=0 Bit2=T Bit1=T Bit0=T
; 0000 00AD PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (1<<PORTB0);
	LDI  R30,LOW(1)
	OUT  0x18,R30
; 0000 00AE 
; 0000 00AF // Port C initialization
; 0000 00B0 // Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In
; 0000 00B1 DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (1<<DDC2) | (1<<DDC1) | (1<<DDC0);
	LDI  R30,LOW(7)
	OUT  0x14,R30
; 0000 00B2 // State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T
; 0000 00B3 PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 00B4 
; 0000 00B5 // Port D initialization
; 0000 00B6 // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In
; 0000 00B7 DDRD=(0<<DDD7) | (1<<DDD6) | (1<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
	LDI  R30,LOW(96)
	OUT  0x11,R30
; 0000 00B8 // State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T
; 0000 00B9 PORTD=(1<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (1<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
	LDI  R30,LOW(136)
	OUT  0x12,R30
; 0000 00BA 
; 0000 00BB 
; 0000 00BC 
; 0000 00BD // Timer/Counter 1 initialization
; 0000 00BE // Clock source: System Clock
; 0000 00BF // Clock value: Timer1 Stopped
; 0000 00C0 // Mode: Normal top=0xFFFF
; 0000 00C1 // OC1A output: Disconnected
; 0000 00C2 // OC1B output: Disconnected
; 0000 00C3 // Noise Canceler: Off
; 0000 00C4 // Input Capture on Falling Edge
; 0000 00C5 // Timer1 Overflow Interrupt: Off
; 0000 00C6 // Input Capture Interrupt: Off
; 0000 00C7 // Compare A Match Interrupt: Off
; 0000 00C8 // Compare B Match Interrupt: Off
; 0000 00C9 TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 00CA TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
	OUT  0x2E,R30
; 0000 00CB TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00CC TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00CD ICR1H=0x00;
	OUT  0x27,R30
; 0000 00CE ICR1L=0x00;
	OUT  0x26,R30
; 0000 00CF OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00D0 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00D1 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00D2 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00D3 
; 0000 00D4 // Timer/Counter 2 initialization
; 0000 00D5 // Clock source: System Clock
; 0000 00D6 // Clock value: 250,000 kHz
; 0000 00D7 // Mode: Fast PWM top=0xFF
; 0000 00D8 // OC2 output: Non-Inverted PWM
; 0000 00D9 // Timer Period: 1,024 ms
; 0000 00DA // Output Pulse(s):
; 0000 00DB // OC2 Period: 1,024 ms Width: 0 us
; 0000 00DC ASSR=0<<AS2;
	OUT  0x22,R30
; 0000 00DD TCCR2=(1<<PWM2) | (1<<COM21) | (0<<COM20) | (1<<CTC2) | (0<<CS22) | (1<<CS21) | (1<<CS20);
	LDI  R30,LOW(107)
	OUT  0x25,R30
; 0000 00DE TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 00DF OCR2 = flow_max; // 
	OUT  0x23,R12
; 0000 00E0 delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
; 0000 00E1 
; 0000 00E2 
; 0000 00E3 
; 0000 00E4 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00E5 TIMSK=(0<<OCIE2) | (1<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 00E6 
; 0000 00E7 // External Interrupt(s) initialization
; 0000 00E8 // INT0: Off
; 0000 00E9 // INT1: On
; 0000 00EA // INT1 Mode: Falling Edge
; 0000 00EB GICR|=(1<<INT1) | (0<<INT0);
	IN   R30,0x3B
	ORI  R30,0x80
	OUT  0x3B,R30
; 0000 00EC MCUCR=(1<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
	LDI  R30,LOW(8)
	OUT  0x35,R30
; 0000 00ED GIFR=(1<<INTF1) | (0<<INTF0);
	LDI  R30,LOW(128)
	OUT  0x3A,R30
; 0000 00EE 
; 0000 00EF 
; 0000 00F0 // USART initialization
; 0000 00F1 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 00F2 // USART Receiver: On
; 0000 00F3 // USART Transmitter: On
; 0000 00F4 // USART Mode: Asynchronous
; 0000 00F5 // USART Baud Rate: 9600
; 0000 00F6 UCSRA=(0<<RXC) | (0<<TXC) | (0<<UDRE) | (0<<FE) | (0<<DOR) | (0<<UPE) | (0<<U2X) | (0<<MPCM);
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 00F7 UCSRB=(1<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (1<<RXEN) | (1<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 00F8 UCSRC=(1<<URSEL) | (0<<UMSEL) | (0<<UPM1) | (0<<UPM0) | (0<<USBS) | (1<<UCSZ1) | (1<<UCSZ0) | (0<<UCPOL);
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 00F9 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 00FA UBRRL=0x33; // 9600
	LDI  R30,LOW(51)
	OUT  0x9,R30
; 0000 00FB 
; 0000 00FC 
; 0000 00FD 
; 0000 00FE // Analog Comparator initialization
; 0000 00FF // Analog Comparator: Off
; 0000 0100 // The Analog Comparator's positive input is
; 0000 0101 // connected to the AIN0 pin
; 0000 0102 // The Analog Comparator's negative input is
; 0000 0103 // connected to the AIN1 pin
; 0000 0104 ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0105 SFIOR=(0<<ACME);
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0106 
; 0000 0107 // ADC initialization
; 0000 0108 // ADC Clock frequency: 1000,000 kHz
; 0000 0109 // ADC Voltage Reference: AREF pin
; 0000 010A ADCSRA=(1<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 010B SFIOR=(0<<ACME);
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 010C 
; 0000 010D 
; 0000 010E 
; 0000 010F 
; 0000 0110 
; 0000 0111 // Global enable interrupts
; 0000 0112 #asm("sei")
	sei
; 0000 0113 
; 0000 0114 while (1)
_0xF:
; 0000 0115   {
; 0000 0116       // Place your code here
; 0000 0117 
; 0000 0118        if(flag_100hz == 1)
	LDS  R26,_flag_100hz
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x12
; 0000 0119          {
; 0000 011A           //PORTC  |= (1<<PORTC0); //1        
; 0000 011B 
; 0000 011C           // Timer/Counter 0 initialization
; 0000 011D           // Clock source: System Clock
; 0000 011E           // Clock value: 7,813 kHz
; 0000 011F           TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 0120           TCNT0=sp;           //250 -  . 181 - 
	LDS  R30,_sp
	OUT  0x32,R30
; 0000 0121           triac_off;       //      .
	CBI  0x18,1
; 0000 0122 
; 0000 0123 
; 0000 0124               flag_pid_on++;
	INC  R8
; 0000 0125            if(flag_pid_on >= 50)      //   
	LDI  R30,LOW(50)
	CP   R8,R30
	BRSH PC+2
	RJMP _0x13
; 0000 0126            {
; 0000 0127              // 
; 0000 0128             temper = 0;
	LDI  R30,LOW(0)
	STS  _temper,R30
	STS  _temper+1,R30
; 0000 0129             ADMUX  |= (1<<MUX0); //  5
	SBI  0x7,0
; 0000 012A             ADMUX  &= ~(1<<MUX1);
	RCALL SUBOPT_0x5
; 0000 012B             ADMUX  |= (1<<MUX2);
; 0000 012C             delay_us(10);
; 0000 012D             for (i = 1; i <= 3; i++)
	LDI  R30,LOW(1)
	MOV  R9,R30
_0x15:
	LDI  R30,LOW(3)
	CP   R30,R9
	BRLO _0x16
; 0000 012E             {                                  //  
; 0000 012F             ADCSRA |= (1<<ADSC);      //      1
	SBI  0x6,6
; 0000 0130             while(!(ADCSRA & (1<<ADIF)))    //  ,   .
_0x17:
	SBIS 0x6,4
; 0000 0131             {}                            //    
	RJMP _0x17
; 0000 0132             temper = temper + ADCW;           // 
	IN   R30,0x4
	IN   R31,0x4+1
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
; 0000 0133             }
	INC  R9
	RJMP _0x15
_0x16:
; 0000 0134             temper = temper/3;
	RCALL SUBOPT_0x6
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL __DIVW21U
	RCALL SUBOPT_0x8
; 0000 0135 
; 0000 0136 
; 0000 0137 
; 0000 0138              // PIDr
; 0000 0139              error = set_temper_aver - temper;
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x9
	SUB  R30,R26
	SBC  R31,R27
	STS  _error,R30
	STS  _error+1,R31
; 0000 013A              if ((control_action > -1)&&(control_action < 1))
	RCALL SUBOPT_0xA
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RCALL SUBOPT_0xB
	BRGE _0x1B
	RCALL SUBOPT_0xA
	SBIW R26,1
	BRLT _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
; 0000 013B              {integral = integral + error;}
	RCALL SUBOPT_0xC
	LDS  R26,_integral
	LDS  R27,_integral+1
	LDS  R24,_integral+2
	LDS  R25,_integral+3
	RCALL __CWD1
	RCALL __ADDD12
	STS  _integral,R30
	STS  _integral+1,R31
	STS  _integral+2,R22
	STS  _integral+3,R23
; 0000 013C              control_action = Kp*error + Ki*integral + Kd*(error - last_error);       //pidr
_0x1A:
	RCALL SUBOPT_0xC
	LDS  R26,_Kp
	LDS  R27,_Kp+1
	LDS  R24,_Kp+2
	LDS  R25,_Kp+3
	RCALL SUBOPT_0xD
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_integral
	LDS  R31,_integral+1
	LDS  R22,_integral+2
	LDS  R23,_integral+3
	LDS  R26,_Ki
	LDS  R27,_Ki+1
	LDS  R24,_Ki+2
	LDS  R25,_Ki+3
	RCALL __CDF1
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xC
	SUB  R30,R10
	SBC  R31,R11
	LDS  R26,_Kd
	LDS  R27,_Kd+1
	LDS  R24,_Kd+2
	LDS  R25,_Kd+3
	RCALL SUBOPT_0xD
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	LDI  R26,LOW(_control_action)
	LDI  R27,HIGH(_control_action)
	RCALL __CFD1
	ST   X+,R30
	ST   X,R31
; 0000 013D              last_error = error;
	__GETWRMN 10,11,0,_error
; 0000 013E              sp = sp + control_action;
	LDS  R30,_control_action
	LDS  R31,_control_action+1
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xF
; 0000 013F              if (sp<181)
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0xB5)
	LDI  R30,HIGH(0xB5)
	CPC  R27,R30
	BRGE _0x1D
; 0000 0140              {sp = 181;}   //  
	LDI  R30,LOW(181)
	LDI  R31,HIGH(181)
	RCALL SUBOPT_0xF
; 0000 0141              if (sp>210)
_0x1D:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0xD3)
	LDI  R30,HIGH(0xD3)
	CPC  R27,R30
	BRLT _0x1E
; 0000 0142              {sp = 210;} //  
	LDI  R30,LOW(210)
	LDI  R31,HIGH(210)
	RCALL SUBOPT_0xF
; 0000 0143 
; 0000 0144 
; 0000 0145              // 
; 0000 0146               if(((set_temper_aver > last_set_temper_aver + 10)|(set_temper_aver < last_set_temper_aver - 10))&&(buzzer_ ...
_0x1E:
	RCALL SUBOPT_0x10
	ADIW R30,10
	RCALL SUBOPT_0x11
	RCALL __GTW12U
	MOV  R0,R30
	RCALL SUBOPT_0x10
	SBIW R30,10
	RCALL SUBOPT_0x11
	RCALL __LTW12U
	OR   R30,R0
	BREQ _0x20
	RCALL SUBOPT_0x12
	CPI  R26,LOW(0x2)
	BREQ _0x21
_0x20:
	RJMP _0x1F
_0x21:
; 0000 0147               {
; 0000 0148                buzzer_flag = 0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x13
; 0000 0149               }
; 0000 014A 
; 0000 014B              //   
; 0000 014C              if(standby_on == 1)
_0x1F:
	LDS  R26,_standby_on
	CPI  R26,LOW(0x1)
	BRNE _0x22
; 0000 014D              {
; 0000 014E                DDRC ^= (1<<DDC1);       // 
	IN   R30,0x14
	LDI  R26,LOW(2)
	EOR  R30,R26
	OUT  0x14,R30
; 0000 014F                DDRC ^= (1<<DDC2);
	IN   R30,0x14
	LDI  R26,LOW(4)
	EOR  R30,R26
	OUT  0x14,R30
; 0000 0150              }
; 0000 0151 
; 0000 0152 
; 0000 0153 
; 0000 0154 
; 0000 0155 
; 0000 0156 
; 0000 0157               //   UART
; 0000 0158                       send_Uart(13);					//	 
_0x22:
	RCALL SUBOPT_0x14
; 0000 0159                       send_Uart_str("$");	//	 
	__POINTW2MN _0x23,0
	RCALL _send_Uart_str
; 0000 015A                       send_int_Uart(temper);			//	 
	RCALL SUBOPT_0x6
	RCALL _send_int_Uart
; 0000 015B                       send_Uart_str(" ");	//	 
	__POINTW2MN _0x23,2
	RCALL _send_Uart_str
; 0000 015C                       send_int_Uart(set_temper_aver);			//	 
	RCALL SUBOPT_0x11
	RCALL _send_int_Uart
; 0000 015D                       send_Uart_str(" ");	//	 
	__POINTW2MN _0x23,4
	RCALL _send_Uart_str
; 0000 015E                       send_int_Uart(OCR2);			//	 
	IN   R30,0x23
	LDI  R31,0
	MOVW R26,R30
	RCALL _send_int_Uart
; 0000 015F                       send_Uart_str(";");	//	 
	__POINTW2MN _0x23,6
	RCALL _send_Uart_str
; 0000 0160 
; 0000 0161 
; 0000 0162 
; 0000 0163 
; 0000 0164 
; 0000 0165 
; 0000 0166 
; 0000 0167 
; 0000 0168 
; 0000 0169 
; 0000 016A 
; 0000 016B              flag_pid_on = 0;
	CLR  R8
; 0000 016C            }
; 0000 016D 
; 0000 016E 
; 0000 016F              flag_flow_adj++;
_0x13:
	LDS  R30,_flag_flow_adj
	SUBI R30,-LOW(1)
	STS  _flag_flow_adj,R30
; 0000 0170              if(flag_flow_adj >= 10)             //   
	LDS  R26,_flag_flow_adj
	CPI  R26,LOW(0xA)
	BRLO _0x24
; 0000 0171              {
; 0000 0172              // 
; 0000 0173              if((error < 10)&&(error > -10)&&(OCR2 < flow))
	RCALL SUBOPT_0x15
	SBIW R26,10
	BRGE _0x26
	RCALL SUBOPT_0x16
	BRGE _0x26
	RCALL SUBOPT_0x17
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x27
_0x26:
	RJMP _0x25
_0x27:
; 0000 0174              {OCR2++;}
	IN   R30,0x23
	SUBI R30,-LOW(1)
	OUT  0x23,R30
; 0000 0175              if((error < 10)&&(error > -10)&&(OCR2 > flow))
_0x25:
	RCALL SUBOPT_0x15
	SBIW R26,10
	BRGE _0x29
	RCALL SUBOPT_0x16
	BRGE _0x29
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xB
	BRLO _0x2A
_0x29:
	RJMP _0x28
_0x2A:
; 0000 0176              {OCR2--;}
	IN   R30,0x23
	SUBI R30,LOW(1)
	OUT  0x23,R30
; 0000 0177              if(error < -20)
_0x28:
	RCALL SUBOPT_0x15
	CPI  R26,LOW(0xFFEC)
	LDI  R30,HIGH(0xFFEC)
	CPC  R27,R30
	BRGE _0x2B
; 0000 0178              {OCR2 = flow_max;}
	OUT  0x23,R12
; 0000 0179              if(error > 20)
_0x2B:
	RCALL SUBOPT_0x15
	SBIW R26,21
	BRLT _0x2C
; 0000 017A              {OCR2 = flow_min;}
	LDS  R30,_flow_min
	OUT  0x23,R30
; 0000 017B 
; 0000 017C              if((sleep_on == 1)&&(temper < temper_min))
_0x2C:
	LDS  R26,_sleep_on
	CPI  R26,LOW(0x1)
	BRNE _0x2E
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x6
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x2F
_0x2E:
	RJMP _0x2D
_0x2F:
; 0000 017D               {
; 0000 017E               OCR2 = 0;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 017F               }
; 0000 0180 
; 0000 0181              flag_flow_adj = 0;
_0x2D:
	LDI  R30,LOW(0)
	STS  _flag_flow_adj,R30
; 0000 0182              }
; 0000 0183 
; 0000 0184 
; 0000 0185 
; 0000 0186              //     
; 0000 0187              if((error < 10)&&(error > -10)&&(OCR2 == flow))
_0x24:
	RCALL SUBOPT_0x15
	SBIW R26,10
	BRGE _0x31
	RCALL SUBOPT_0x16
	BRGE _0x31
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xB
	BREQ _0x32
_0x31:
	RJMP _0x30
_0x32:
; 0000 0188              {
; 0000 0189               led_red_on;
	SBI  0x15,2
; 0000 018A               led_green_on;
	SBI  0x15,1
; 0000 018B               if(buzzer_flag == 0)
	LDS  R30,_buzzer_flag
	CPI  R30,0
	BRNE _0x33
; 0000 018C               {buzzer_flag = 1;}
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x13
; 0000 018D              }
_0x33:
; 0000 018E              if(error >= 10)
_0x30:
	RCALL SUBOPT_0x15
	SBIW R26,10
	BRLT _0x34
; 0000 018F              {
; 0000 0190               led_red_off;
	CBI  0x15,2
; 0000 0191               led_green_on;
	SBI  0x15,1
; 0000 0192              }
; 0000 0193              if(error <= -10)
_0x34:
	RCALL SUBOPT_0x16
	BRLT _0x35
; 0000 0194              {
; 0000 0195               led_green_off;
	CBI  0x15,1
; 0000 0196               led_red_on;
	SBI  0x15,2
; 0000 0197              }
; 0000 0198 
; 0000 0199 
; 0000 019A 
; 0000 019B 
; 0000 019C 
; 0000 019D 
; 0000 019E 
; 0000 019F              //  
; 0000 01A0               ADMUX  &= ~(1<<MUX0);      //  4
_0x35:
	CBI  0x7,0
; 0000 01A1               ADMUX  &= ~(1<<MUX1);
	RCALL SUBOPT_0x5
; 0000 01A2               ADMUX  |= (1<<MUX2);
; 0000 01A3               delay_us(10);
; 0000 01A4               ADCSRA |= (1<<ADSC);      //      1
	SBI  0x6,6
; 0000 01A5               while(!(ADCSRA & (1<<ADIF)))    //  ,   .
_0x36:
	SBIS 0x6,4
; 0000 01A6               {}             //    
	RJMP _0x36
; 0000 01A7               set_temper = ADCW;   // 
	IN   R30,0x4
	IN   R31,0x4+1
	STS  _set_temper,R30
	STS  _set_temper+1,R31
; 0000 01A8               set_temper_adc_aver = (1 - coefLPF) * set_temper_adc_aver + set_temper * coefLPF; // 
	LDS  R30,_set_temper_adc_aver
	LDS  R31,_set_temper_adc_aver+1
	LDS  R22,_set_temper_adc_aver+2
	LDS  R23,_set_temper_adc_aver+3
	RCALL SUBOPT_0x19
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_set_temper
	LDS  R31,_set_temper+1
	RCALL SUBOPT_0x1A
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	LDI  R26,LOW(_set_temper_adc_aver)
	LDI  R27,HIGH(_set_temper_adc_aver)
	RCALL __CFD1U
	RCALL __PUTDP1
; 0000 01A9               set_temper_aver = ((set_temper_adc_aver * (temper_max - temper_min))/1024)+temper_min;    //   ...
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1C
	SUB  R30,R26
	SBC  R31,R27
	LDS  R26,_set_temper_adc_aver
	LDS  R27,_set_temper_adc_aver+1
	LDS  R24,_set_temper_adc_aver+2
	LDS  R25,_set_temper_adc_aver+3
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x1E
; 0000 01AA 
; 0000 01AB 
; 0000 01AC               //  
; 0000 01AD               if(reed_switch_time >= 18025)  // 100hz * 180 = 3             
	RCALL SUBOPT_0x1F
	BRLO _0x39
; 0000 01AE               {
; 0000 01AF                set_temper_aver = 100;
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x1E
; 0000 01B0               }
; 0000 01B1               if(reed_switch_time == 18025)
_0x39:
	RCALL SUBOPT_0x1F
	BRNE _0x3A
; 0000 01B2               {
; 0000 01B3                standby_on = 1;
	LDI  R30,LOW(1)
	STS  _standby_on,R30
; 0000 01B4               }
; 0000 01B5 
; 0000 01B6 
; 0000 01B7               //  
; 0000 01B8               if(reed_switch_time >= 36000)    // 6       
_0x3A:
	RCALL SUBOPT_0x20
	CPI  R26,LOW(0x8CA0)
	LDI  R30,HIGH(0x8CA0)
	CPC  R27,R30
	BRLO _0x3B
; 0000 01B9               {
; 0000 01BA                set_temper_aver = temper_min;
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1E
; 0000 01BB                DDRB &= ~(1<<DDB1);            //   
	CBI  0x17,1
; 0000 01BC                reed_switch_time = 36000;      //     
	LDI  R30,LOW(36000)
	LDI  R31,HIGH(36000)
	STS  _reed_switch_time,R30
	STS  _reed_switch_time+1,R31
; 0000 01BD 
; 0000 01BE                sleep_on = 1;
	LDI  R30,LOW(1)
	STS  _sleep_on,R30
; 0000 01BF 
; 0000 01C0               }
; 0000 01C1 
; 0000 01C2 
; 0000 01C3 
; 0000 01C4               if(power_off)           //  
_0x3B:
	SBIS 0x16,0
	RJMP _0x3C
; 0000 01C5               {set_temper_aver = 0;
	LDI  R30,LOW(0)
	STS  _set_temper_aver,R30
	STS  _set_temper_aver+1,R30
; 0000 01C6 
; 0000 01C7                }
; 0000 01C8 
; 0000 01C9 
; 0000 01CA 
; 0000 01CB 
; 0000 01CC 
; 0000 01CD 
; 0000 01CE 
; 0000 01CF 
; 0000 01D0 
; 0000 01D1 
; 0000 01D2 
; 0000 01D3 
; 0000 01D4              //  
; 0000 01D5               ADMUX  |= (1<<MUX0);      //  3
_0x3C:
	SBI  0x7,0
; 0000 01D6               ADMUX  |= (1<<MUX1);
	SBI  0x7,1
; 0000 01D7               ADMUX  &= ~(1<<MUX2);
	CBI  0x7,2
; 0000 01D8               delay_us(10);
	__DELAY_USB 27
; 0000 01D9               ADCSRA |= (1<<ADSC);      //      1
	SBI  0x6,6
; 0000 01DA               while(!(ADCSRA & (1<<ADIF)))    //  ,   .
_0x3D:
	SBIS 0x6,4
; 0000 01DB               {}             //    
	RJMP _0x3D
; 0000 01DC               set_flow = ADCW;   //  
	IN   R30,0x4
	IN   R31,0x4+1
	STS  _set_flow,R30
	STS  _set_flow+1,R31
; 0000 01DD               set_flow_aver = (1 - coefLPF) * set_flow_aver + set_flow * coefLPF; // 
	LDS  R30,_set_flow_aver
	LDS  R31,_set_flow_aver+1
	LDS  R22,_set_flow_aver+2
	LDS  R23,_set_flow_aver+3
	RCALL SUBOPT_0x19
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_set_flow
	LDS  R31,_set_flow+1
	RCALL SUBOPT_0x1A
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	LDI  R26,LOW(_set_flow_aver)
	LDI  R27,HIGH(_set_flow_aver)
	RCALL __CFD1U
	RCALL __PUTDP1
; 0000 01DE               flow = ((set_flow_aver * (flow_max - flow_min))/1024)+flow_min;     //     
	RCALL SUBOPT_0x21
	MOVW R30,R12
	SUB  R30,R26
	SBC  R31,R27
	LDS  R26,_set_flow_aver
	LDS  R27,_set_flow_aver+1
	LDS  R24,_set_flow_aver+2
	LDS  R25,_set_flow_aver+3
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x22
; 0000 01DF               if(standby_on == 1)
	LDS  R26,_standby_on
	CPI  R26,LOW(0x1)
	BRNE _0x40
; 0000 01E0               {
; 0000 01E1                flow = flow_min;
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x22
; 0000 01E2               }
; 0000 01E3 
; 0000 01E4 
; 0000 01E5 
; 0000 01E6 
; 0000 01E7                                /*
; 0000 01E8              // 
; 0000 01E9               if(reed_switch_on)
; 0000 01EA               {
; 0000 01EB                reed_switch_time++;        //   
; 0000 01EC               }
; 0000 01ED 
; 0000 01EE               if( (power_off)|((reed_switch_off)&&(sleep_on == 0))|((sleep_on == 1)&&((flow > last_flow + 10)|(flow < la ...
; 0000 01EF               {
; 0000 01F0                reed_switch_time = 0;     //    
; 0000 01F1                DDRB |= (1<<DDB1);       //     
; 0000 01F2                DDRC |= (1<<DDC1);       //   
; 0000 01F3                DDRC |= (1<<DDC2);
; 0000 01F4                sleep_on = 0;
; 0000 01F5               }
; 0000 01F6 
; 0000 01F7                                */
; 0000 01F8 
; 0000 01F9                reed_switch_time++;        //   
_0x40:
	LDI  R26,LOW(_reed_switch_time)
	LDI  R27,HIGH(_reed_switch_time)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 01FA 
; 0000 01FB                if ((sleep_on == 1)&&((flow > last_flow + 10)|(flow < last_flow - 10))) //       ...
	LDS  R26,_sleep_on
	CPI  R26,LOW(0x1)
	BRNE _0x42
	RCALL SUBOPT_0x24
	ADIW R30,10
	RCALL SUBOPT_0x25
	RCALL __GTW12U
	MOV  R0,R30
	RCALL SUBOPT_0x24
	SBIW R30,10
	RCALL SUBOPT_0x25
	RCALL __LTW12U
	OR   R30,R0
	BRNE _0x43
_0x42:
	RJMP _0x41
_0x43:
; 0000 01FC               {
; 0000 01FD                reed_switch_time = 0;     //    
	RCALL SUBOPT_0x26
; 0000 01FE                DDRB |= (1<<DDB1);       //     
	SBI  0x17,1
; 0000 01FF                DDRC |= (1<<DDC1);       //   
	SBI  0x14,1
; 0000 0200                DDRC |= (1<<DDC2);
	SBI  0x14,2
; 0000 0201                sleep_on = 2;
	LDI  R30,LOW(2)
	STS  _sleep_on,R30
; 0000 0202               }
; 0000 0203 
; 0000 0204                                   //   ,       
; 0000 0205               if (reed_switch_off)
_0x41:
	SBIC 0x10,7
	RJMP _0x44
; 0000 0206               {
; 0000 0207                NewState = 0;
	LDI  R30,LOW(0)
	RJMP _0x7E
; 0000 0208               }
; 0000 0209               else
_0x44:
; 0000 020A               {
; 0000 020B                NewState = 1;
	LDI  R30,LOW(1)
_0x7E:
	STS  _NewState,R30
; 0000 020C               }
; 0000 020D 
; 0000 020E 
; 0000 020F               if((NewState!=OldState)&&(sleep_on == 0))           //  
	LDS  R30,_OldState
	LDS  R26,_NewState
	CP   R30,R26
	BREQ _0x47
	LDS  R26,_sleep_on
	CPI  R26,LOW(0x0)
	BREQ _0x48
_0x47:
	RJMP _0x46
_0x48:
; 0000 0210                {
; 0000 0211 
; 0000 0212                   reed_switch_time = 0;     //    
	RCALL SUBOPT_0x26
; 0000 0213                   DDRC |= (1<<DDC1);       //   
	SBI  0x14,1
; 0000 0214                   DDRC |= (1<<DDC2);
	SBI  0x14,2
; 0000 0215 
; 0000 0216                    OldState=NewState;
	LDS  R30,_NewState
	STS  _OldState,R30
; 0000 0217                }
; 0000 0218 
; 0000 0219 
; 0000 021A 
; 0000 021B 
; 0000 021C 
; 0000 021D 
; 0000 021E 
; 0000 021F 
; 0000 0220 
; 0000 0221 
; 0000 0222               //    
; 0000 0223               if((reed_switch_time == 16880)|(reed_switch_time == 17280)|(reed_switch_time == 17580)|(reed_switch_time = ...
_0x46:
	RCALL SUBOPT_0x20
	LDI  R30,LOW(16880)
	LDI  R31,HIGH(16880)
	RCALL SUBOPT_0x27
	LDI  R30,LOW(17280)
	LDI  R31,HIGH(17280)
	RCALL SUBOPT_0x28
	LDI  R30,LOW(17580)
	LDI  R31,HIGH(17580)
	RCALL SUBOPT_0x28
	LDI  R30,LOW(17780)
	LDI  R31,HIGH(17780)
	RCALL SUBOPT_0x28
	LDI  R30,LOW(17880)
	LDI  R31,HIGH(17880)
	RCALL SUBOPT_0x29
	BREQ _0x49
; 0000 0224               {
; 0000 0225                buzzer_flag = 3;   //0,02
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x13
; 0000 0226               }
; 0000 0227               if(reed_switch_time == 17980)
_0x49:
	RCALL SUBOPT_0x20
	CPI  R26,LOW(0x463C)
	LDI  R30,HIGH(0x463C)
	CPC  R27,R30
	BRNE _0x4A
; 0000 0228               {
; 0000 0229                buzzer_flag = 1;   //0,2
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x13
; 0000 022A               }
; 0000 022B               if((reed_switch_time == 18010)|(reed_switch_time == 18025))
_0x4A:
	RCALL SUBOPT_0x20
	LDI  R30,LOW(18010)
	LDI  R31,HIGH(18010)
	RCALL SUBOPT_0x27
	LDI  R30,LOW(18025)
	LDI  R31,HIGH(18025)
	RCALL SUBOPT_0x29
	BREQ _0x4B
; 0000 022C               {
; 0000 022D                buzzer_flag = 4;   //0,05
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x13
; 0000 022E               }
; 0000 022F 
; 0000 0230 
; 0000 0231 
; 0000 0232               //    
; 0000 0233               if(reed_switch_time == 35935)
_0x4B:
	RCALL SUBOPT_0x20
	CPI  R26,LOW(0x8C5F)
	LDI  R30,HIGH(0x8C5F)
	CPC  R27,R30
	BRNE _0x4C
; 0000 0234               {
; 0000 0235                buzzer_flag = 1;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x13
; 0000 0236               }
; 0000 0237               if((reed_switch_time == 35965)|(reed_switch_time == 35980)|(reed_switch_time == 35995))
_0x4C:
	RCALL SUBOPT_0x20
	LDI  R30,LOW(35965)
	LDI  R31,HIGH(35965)
	RCALL SUBOPT_0x27
	LDI  R30,LOW(35980)
	LDI  R31,HIGH(35980)
	RCALL SUBOPT_0x28
	LDI  R30,LOW(35995)
	LDI  R31,HIGH(35995)
	RCALL SUBOPT_0x29
	BREQ _0x4D
; 0000 0238               {
; 0000 0239                buzzer_flag = 4;   //0,05
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x2A
; 0000 023A                standby_on = 0;
	STS  _standby_on,R30
; 0000 023B                last_flow = flow;                            //   
	LDS  R30,_flow
	LDS  R31,_flow+1
	STS  _last_flow,R30
	STS  _last_flow+1,R31
; 0000 023C               }
; 0000 023D 
; 0000 023E 
; 0000 023F               //       
; 0000 0240               if(((reed_switch_time == 0)|(reed_switch_time == 12))&&((standby_on == 1)|(sleep_on == 2)))
_0x4D:
	RCALL SUBOPT_0x20
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x27
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL SUBOPT_0x29
	BREQ _0x4F
	LDS  R26,_standby_on
	LDI  R30,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	LDS  R26,_sleep_on
	LDI  R30,LOW(2)
	RCALL __EQB12
	OR   R30,R0
	BRNE _0x50
_0x4F:
	RJMP _0x4E
_0x50:
; 0000 0241               {
; 0000 0242                buzzer_flag = 3;
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x13
; 0000 0243                if(reed_switch_time == 12)
	RCALL SUBOPT_0x20
	SBIW R26,12
	BRNE _0x51
; 0000 0244                {
; 0000 0245                 standby_on = 0;
	LDI  R30,LOW(0)
	STS  _standby_on,R30
; 0000 0246                 sleep_on = 0;
	STS  _sleep_on,R30
; 0000 0247                }
; 0000 0248               }
_0x51:
; 0000 0249 
; 0000 024A 
; 0000 024B 
; 0000 024C 
; 0000 024D 
; 0000 024E              //  
; 0000 024F               if(power_on)             //   
_0x4E:
	SBIS 0x16,0
; 0000 0250               {relay_on;}
	SBI  0x12,5
; 0000 0251               if((power_off)&&(temper < temper_min)) //     
	SBIS 0x16,0
	RJMP _0x54
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x6
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x55
_0x54:
	RJMP _0x53
_0x55:
; 0000 0252               {relay_off;}
	CBI  0x12,5
; 0000 0253 
; 0000 0254 
; 0000 0255 
; 0000 0256 
; 0000 0257 
; 0000 0258 
; 0000 0259 
; 0000 025A 
; 0000 025B 
; 0000 025C 
; 0000 025D              // 1    0,2
; 0000 025E              if(buzzer_flag == 1)
_0x53:
	RCALL SUBOPT_0x12
	CPI  R26,LOW(0x1)
	BRNE _0x56
; 0000 025F              {
; 0000 0260               buzzer_on;
	RCALL SUBOPT_0x2B
; 0000 0261               buzzer_time++;
; 0000 0262 
; 0000 0263                if(buzzer_time >= 20)
	CPI  R26,LOW(0x14)
	BRLO _0x57
; 0000 0264                {
; 0000 0265                 buzzer_off;
	RCALL SUBOPT_0x2C
; 0000 0266                 buzzer_flag = 2;
; 0000 0267                 buzzer_time = 0;
	STS  _buzzer_time,R30
; 0000 0268                 last_set_temper_aver = set_temper_aver;
	RCALL SUBOPT_0x9
	STS  _last_set_temper_aver,R30
	STS  _last_set_temper_aver+1,R31
; 0000 0269                }
; 0000 026A              }
_0x57:
; 0000 026B 
; 0000 026C 
; 0000 026D 
; 0000 026E              // 2    0,02
; 0000 026F              if(buzzer_flag == 3)
_0x56:
	RCALL SUBOPT_0x12
	CPI  R26,LOW(0x3)
	BRNE _0x58
; 0000 0270              {
; 0000 0271               buzzer_on;
	RCALL SUBOPT_0x2B
; 0000 0272               buzzer_time++;
; 0000 0273 
; 0000 0274                if(buzzer_time >= 2)
	CPI  R26,LOW(0x2)
	BRLO _0x59
; 0000 0275                {
; 0000 0276                 buzzer_off;
	RCALL SUBOPT_0x2C
; 0000 0277                 buzzer_flag = 2;
; 0000 0278                 buzzer_time = 0;
	STS  _buzzer_time,R30
; 0000 0279                }
; 0000 027A              }
_0x59:
; 0000 027B 
; 0000 027C 
; 0000 027D 
; 0000 027E              // 3    0,05
; 0000 027F              if(buzzer_flag == 4)
_0x58:
	RCALL SUBOPT_0x12
	CPI  R26,LOW(0x4)
	BRNE _0x5A
; 0000 0280              {
; 0000 0281               buzzer_on;
	RCALL SUBOPT_0x2B
; 0000 0282               buzzer_time++;
; 0000 0283 
; 0000 0284                if(buzzer_time >= 5)
	CPI  R26,LOW(0x5)
	BRLO _0x5B
; 0000 0285                {
; 0000 0286                 buzzer_off;
	RCALL SUBOPT_0x2C
; 0000 0287                 buzzer_flag = 2;
; 0000 0288                 buzzer_time = 0;
	STS  _buzzer_time,R30
; 0000 0289                }
; 0000 028A              }
_0x5B:
; 0000 028B 
; 0000 028C 
; 0000 028D 
; 0000 028E 
; 0000 028F 
; 0000 0290 
; 0000 0291 
; 0000 0292 
; 0000 0293 
; 0000 0294 
; 0000 0295 
; 0000 0296 
; 0000 0297              //   UART
; 0000 0298              if(parameters_out == 1)
_0x5A:
	LDS  R26,_parameters_out
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x5C
; 0000 0299              {
; 0000 029A               switch (rx_buffer[1])
	__GETD1MN _rx_buffer,4
; 0000 029B                {
; 0000 029C                 case 'a':
	__CPD1N 0x61
	BRNE _0x60
; 0000 029D                       flow_min = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2
; 0000 029E                       eeflow_min = flow_min;
	RCALL SUBOPT_0x23
	LDI  R26,LOW(_eeflow_min)
	LDI  R27,HIGH(_eeflow_min)
	RCALL __EEPROMWRW
; 0000 029F                 break;
	RJMP _0x5F
; 0000 02A0 
; 0000 02A1                 case 'b':
_0x60:
	__CPD1N 0x62
	BRNE _0x61
; 0000 02A2                       flow_max = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
	RCALL SUBOPT_0x2D
	MOVW R12,R30
; 0000 02A3                       eeflow_max = flow_max;
	LDI  R26,LOW(_eeflow_max)
	LDI  R27,HIGH(_eeflow_max)
	RCALL __EEPROMWRW
; 0000 02A4                 break;
	RJMP _0x5F
; 0000 02A5 
; 0000 02A6                 case 'c':
_0x61:
	__CPD1N 0x63
	BRNE _0x62
; 0000 02A7                       temper_min = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x3
; 0000 02A8                       eetemper_min = temper_min;
	RCALL SUBOPT_0x18
	LDI  R26,LOW(_eetemper_min)
	LDI  R27,HIGH(_eetemper_min)
	RCALL __EEPROMWRW
; 0000 02A9                 break;
	RJMP _0x5F
; 0000 02AA 
; 0000 02AB                 case 'd':
_0x62:
	__CPD1N 0x64
	BRNE _0x63
; 0000 02AC                       temper_max = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x4
; 0000 02AD                       eetemper_max = temper_max;
	RCALL SUBOPT_0x1C
	LDI  R26,LOW(_eetemper_max)
	LDI  R27,HIGH(_eetemper_max)
	RCALL __EEPROMWRW
; 0000 02AE                 break;
	RJMP _0x5F
; 0000 02AF 
; 0000 02B0                 case '1':
_0x63:
	__CPD1N 0x31
	BRNE _0x64
; 0000 02B1                      eeflag_primary_values = 255;  //     
	LDI  R26,LOW(_eeflag_primary_values)
	LDI  R27,HIGH(_eeflag_primary_values)
	LDI  R30,LOW(255)
	RCALL __EEPROMWRB
; 0000 02B2                      send_Uart(13);                    //     
	RCALL SUBOPT_0x14
; 0000 02B3                      send_Uart_str("primary_values");    //     
	__POINTW2MN _0x23,8
	RCALL _send_Uart_str
; 0000 02B4                 break;
	RJMP _0x5F
; 0000 02B5 
; 0000 02B6                 case '0': //        
_0x64:
	__CPD1N 0x30
	BRNE _0x5F
; 0000 02B7                       send_Uart(13);					//	 
	RCALL SUBOPT_0x14
; 0000 02B8                       send_Uart_str("flow_min ");	//	 
	__POINTW2MN _0x23,23
	RCALL _send_Uart_str
; 0000 02B9                       send_Uart_str("a");	//	 
	__POINTW2MN _0x23,33
	RCALL _send_Uart_str
; 0000 02BA                       send_int_Uart(flow_min);			//	 
	RCALL SUBOPT_0x21
	RCALL _send_int_Uart
; 0000 02BB                       send_Uart(13);					//	 
	RCALL SUBOPT_0x14
; 0000 02BC                       send_Uart_str("flow_max ");	//	 
	__POINTW2MN _0x23,35
	RCALL _send_Uart_str
; 0000 02BD                       send_Uart_str("b");	//	 
	__POINTW2MN _0x23,45
	RCALL _send_Uart_str
; 0000 02BE                       send_int_Uart(flow_max);			//	 
	MOVW R26,R12
	RCALL _send_int_Uart
; 0000 02BF                       send_Uart(13);					//	 
	RCALL SUBOPT_0x14
; 0000 02C0                       send_Uart_str("temper_min ");	//	 
	__POINTW2MN _0x23,47
	RCALL _send_Uart_str
; 0000 02C1                       send_Uart_str("c");	//	 
	__POINTW2MN _0x23,59
	RCALL _send_Uart_str
; 0000 02C2                       send_int_Uart(temper_min);			//	 
	RCALL SUBOPT_0x1B
	RCALL _send_int_Uart
; 0000 02C3                       send_Uart(13);					//	 
	RCALL SUBOPT_0x14
; 0000 02C4                       send_Uart_str("temper_max ");	//	 
	__POINTW2MN _0x23,61
	RCALL _send_Uart_str
; 0000 02C5                       send_Uart_str("d");	//	 
	__POINTW2MN _0x23,73
	RCALL _send_Uart_str
; 0000 02C6                       send_int_Uart(temper_max);			//	 
	LDS  R26,_temper_max
	LDS  R27,_temper_max+1
	RCALL _send_int_Uart
; 0000 02C7 
; 0000 02C8 
; 0000 02C9 
; 0000 02CA                 break;
; 0000 02CB 
; 0000 02CC                }
_0x5F:
; 0000 02CD 
; 0000 02CE 
; 0000 02CF 
; 0000 02D0 
; 0000 02D1 
; 0000 02D2 
; 0000 02D3               parameters_out = 0;
	LDI  R30,LOW(0)
	STS  _parameters_out,R30
; 0000 02D4              }
; 0000 02D5 
; 0000 02D6 
; 0000 02D7 
; 0000 02D8 
; 0000 02D9 
; 0000 02DA 
; 0000 02DB 
; 0000 02DC           //PORTC  &= ~(1<<PORTC0); //0  
; 0000 02DD           flag_100hz = 0;//     
_0x5C:
	LDI  R30,LOW(0)
	STS  _flag_100hz,R30
; 0000 02DE          }
; 0000 02DF 
; 0000 02E0 
; 0000 02E1 
; 0000 02E2                  /*
; 0000 02E3        if (reed_switch_off)          //  
; 0000 02E4               {
; 0000 02E5                NewState = 0;
; 0000 02E6               }
; 0000 02E7               else
; 0000 02E8               {
; 0000 02E9                NewState = 1;
; 0000 02EA               }
; 0000 02EB 
; 0000 02EC 
; 0000 02ED 
; 0000 02EE       if((NewState!=OldState)&&(sleep_on == 0))           //  
; 0000 02EF                {
; 0000 02F0 
; 0000 02F1                   reed_switch_time = 0;     //    
; 0000 02F2                   OldState=NewState;
; 0000 02F3                }
; 0000 02F4 
; 0000 02F5                */
; 0000 02F6 
; 0000 02F7   }
_0x12:
	RJMP _0xF
; 0000 02F8 }
_0x66:
	RJMP _0x66
; .FEND

	.DSEG
_0x23:
	.BYTE 0x4B
;
;
;
;
;    // External Interrupt 1 service routine     
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 02FF {

	.CSEG
_ext_int1_isr:
; .FSTART _ext_int1_isr
	ST   -Y,R30
; 0000 0300 // Place your code here
; 0000 0301 
; 0000 0302 flag_100hz = 1;        //     
	LDI  R30,LOW(1)
	STS  _flag_100hz,R30
; 0000 0303 
; 0000 0304 }
	LD   R30,Y+
	RETI
; .FEND
;
;
;// Timer 0 overflow interrupt service routine  
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0309 {
_timer0_ovf_isr:
; .FSTART _timer0_ovf_isr
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 030A // Place your code here
; 0000 030B 
; 0000 030C    switch (flag_phase)              //     
	LDS  R30,_flag_phase
	LDI  R31,0
; 0000 030D     {
; 0000 030E     case 0:
	SBIW R30,0
	BRNE _0x6A
; 0000 030F           triac_on;
	SBI  0x18,1
; 0000 0310           TCNT0=252;
	LDI  R30,LOW(252)
	OUT  0x32,R30
; 0000 0311           flag_phase = 1;
	LDI  R30,LOW(1)
	RJMP _0x7F
; 0000 0312     break;
; 0000 0313 
; 0000 0314 
; 0000 0315     case 1:
_0x6A:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x69
; 0000 0316           triac_off;
	CBI  0x18,1
; 0000 0317           TCCR0 = 0;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0318           flag_phase = 0;
_0x7F:
	STS  _flag_phase,R30
; 0000 0319     break;
; 0000 031A 
; 0000 031B 
; 0000 031C     }
_0x69:
; 0000 031D 
; 0000 031E 
; 0000 031F }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
; .FEND
;
;// Timer2 overflow interrupt service routine       
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0323 {
_timer2_ovf_isr:
; .FSTART _timer2_ovf_isr
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0324 // Place your code here
; 0000 0325 
; 0000 0326 
; 0000 0327  //  
; 0000 0328 
; 0000 0329           if(reed_switch_time >= 36000)    // 6       
	RCALL SUBOPT_0x20
	CPI  R26,LOW(0x8CA0)
	LDI  R30,HIGH(0x8CA0)
	CPC  R27,R30
	BRLO _0x6C
; 0000 032A               {
; 0000 032B 
; 0000 032C                led_pwm_off++;
	LDS  R30,_led_pwm_off
	SUBI R30,-LOW(1)
	STS  _led_pwm_off,R30
; 0000 032D 
; 0000 032E                if((led_pwm_off >= 30)&&(led_pwm_flag == 0))
	LDS  R26,_led_pwm_off
	CPI  R26,LOW(0x1E)
	BRLO _0x6E
	LDS  R26,_led_pwm_flag
	CPI  R26,LOW(0x0)
	BREQ _0x6F
_0x6E:
	RJMP _0x6D
_0x6F:
; 0000 032F                 {
; 0000 0330                  //ledsoff;
; 0000 0331                  DDRC &= ~(1<<DDC1);
	RCALL SUBOPT_0x2E
; 0000 0332                  DDRC &= ~(1<<DDC2);
; 0000 0333                  led_pwm_off = 0;
; 0000 0334                  led_pwm_on++;
	SUBI R30,-LOW(1)
	STS  _led_pwm_on,R30
; 0000 0335 
; 0000 0336                 }
; 0000 0337 
; 0000 0338                 if((led_pwm_off >= 30)&&(led_pwm_flag == 1))
_0x6D:
	LDS  R26,_led_pwm_off
	CPI  R26,LOW(0x1E)
	BRLO _0x71
	LDS  R26,_led_pwm_flag
	CPI  R26,LOW(0x1)
	BREQ _0x72
_0x71:
	RJMP _0x70
_0x72:
; 0000 0339                 {
; 0000 033A                  //ledsoff;
; 0000 033B                  DDRC &= ~(1<<DDC1);
	RCALL SUBOPT_0x2E
; 0000 033C                  DDRC &= ~(1<<DDC2);
; 0000 033D                  led_pwm_off = 0;
; 0000 033E                  led_pwm_on--;
	SUBI R30,LOW(1)
	STS  _led_pwm_on,R30
; 0000 033F 
; 0000 0340                 }
; 0000 0341 
; 0000 0342 
; 0000 0343 
; 0000 0344                 if(led_pwm_off > led_pwm_on)
_0x70:
	LDS  R30,_led_pwm_on
	LDS  R26,_led_pwm_off
	CP   R30,R26
	BRSH _0x73
; 0000 0345                 {
; 0000 0346                  //ledson;
; 0000 0347                  DDRC |= (1<<DDC1);
	SBI  0x14,1
; 0000 0348                  DDRC |= (1<<DDC2);
	SBI  0x14,2
; 0000 0349                 }
; 0000 034A 
; 0000 034B                 if(led_pwm_on >= 28)
_0x73:
	LDS  R26,_led_pwm_on
	CPI  R26,LOW(0x1C)
	BRLO _0x74
; 0000 034C                 {
; 0000 034D                  led_pwm_flag = 1;
	LDI  R30,LOW(1)
	STS  _led_pwm_flag,R30
; 0000 034E                 }
; 0000 034F 
; 0000 0350                 if(led_pwm_on <= 0)
_0x74:
	LDS  R26,_led_pwm_on
	CPI  R26,0
	BRNE _0x75
; 0000 0351                 {
; 0000 0352                  led_pwm_flag = 0;
	LDI  R30,LOW(0)
	STS  _led_pwm_flag,R30
; 0000 0353                 }
; 0000 0354 
; 0000 0355                }
_0x75:
; 0000 0356 
; 0000 0357 }
_0x6C:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
; .FEND
;
;
;  // USART 
;interrupt [USART_RXC] void usart_rx(void)
; 0000 035C  {
_usart_rx:
; .FSTART _usart_rx
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 035D   // Place your code here
; 0000 035E 
; 0000 035F       char status,data;
; 0000 0360 	status=UCSRA;
	RCALL __SAVELOCR2
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 0361 	data=UDR;
	IN   R16,12
; 0000 0362 	if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x76
; 0000 0363 	{
; 0000 0364 		if (data =='(')
	CPI  R16,40
	BRNE _0x77
; 0000 0365 		{
; 0000 0366 			rx_wr_index=0;
	CLR  R5
; 0000 0367 			read_enable = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
; 0000 0368 
; 0000 0369 	 	}
; 0000 036A 
; 0000 036B 		if((data == ')')&&(read_enable == 1))
_0x77:
	CPI  R16,41
	BRNE _0x79
	LDI  R30,LOW(1)
	CP   R30,R4
	BREQ _0x7A
_0x79:
	RJMP _0x78
_0x7A:
; 0000 036C 		{
; 0000 036D 				read_enable = 0;
	CLR  R4
; 0000 036E 				parameters_out = 1;
	LDI  R30,LOW(1)
	STS  _parameters_out,R30
; 0000 036F 		}
; 0000 0370 
; 0000 0371 		if (read_enable == 1)
_0x78:
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x7B
; 0000 0372 		{
; 0000 0373 			rx_buffer[rx_wr_index++]=data;
	MOV  R30,R5
	INC  R5
	LDI  R26,LOW(_rx_buffer)
	LDI  R27,HIGH(_rx_buffer)
	LDI  R31,0
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTDP1
; 0000 0374 			if (rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
	LDI  R30,LOW(5)
	CP   R30,R5
	BRNE _0x7C
	CLR  R5
; 0000 0375 
; 0000 0376 			if (++rx_counter == RX_BUFFER_SIZE)
_0x7C:
	INC  R7
	LDI  R30,LOW(5)
	CP   R30,R7
	BRNE _0x7D
; 0000 0377 			{
; 0000 0378 				rx_counter=0;
	CLR  R7
; 0000 0379 				rx_buffer_overflow=1;
	LDI  R30,LOW(1)
	MOV  R6,R30
; 0000 037A 			}
; 0000 037B 
; 0000 037C 		}
_0x7D:
; 0000 037D 
; 0000 037E 	}
_0x7B:
; 0000 037F 
; 0000 0380 
; 0000 0381 
; 0000 0382  }
_0x76:
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_rx_buffer:
	.BYTE 0x14
_parameters_out:
	.BYTE 0x1
_flag_phase:
	.BYTE 0x1
_flag_100hz:
	.BYTE 0x1
_temper:
	.BYTE 0x2
_set_temper:
	.BYTE 0x2
_set_temper_adc_aver:
	.BYTE 0x4
_set_temper_aver:
	.BYTE 0x2
_last_set_temper_aver:
	.BYTE 0x2
_error:
	.BYTE 0x2
_integral:
	.BYTE 0x4
_Kp:
	.BYTE 0x4
_Ki:
	.BYTE 0x4
_Kd:
	.BYTE 0x4
_control_action:
	.BYTE 0x2
_sp:
	.BYTE 0x2
_set_flow_aver:
	.BYTE 0x4
_set_flow:
	.BYTE 0x2
_flow:
	.BYTE 0x2
_last_flow:
	.BYTE 0x2
_flow_min:
	.BYTE 0x2
_temper_min:
	.BYTE 0x2
_temper_max:
	.BYTE 0x2
_buzzer_flag:
	.BYTE 0x1
_buzzer_time:
	.BYTE 0x1
_flag_flow_adj:
	.BYTE 0x1
_reed_switch_time:
	.BYTE 0x2
_led_pwm_off:
	.BYTE 0x1
_led_pwm_on:
	.BYTE 0x1
_led_pwm_flag:
	.BYTE 0x1
_sleep_on:
	.BYTE 0x1
_standby_on:
	.BYTE 0x1
_NewState:
	.BYTE 0x1
_OldState:
	.BYTE 0x1

	.ESEG
_eeflow_min:
	.BYTE 0x2
_eeflow_max:
	.BYTE 0x2
_eetemper_min:
	.BYTE 0x2
_eetemper_max:
	.BYTE 0x2
_eeflag_primary_values:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	MOV  R26,R17
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	SUBI R30,-LOW(48)
	MOV  R26,R30
	RJMP _send_Uart

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	STS  _flow_min,R30
	STS  _flow_min+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	STS  _temper_min,R30
	STS  _temper_min+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	STS  _temper_max,R30
	STS  _temper_max+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	CBI  0x7,1
	SBI  0x7,2
	__DELAY_USB 27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x6:
	LDS  R26,_temper
	LDS  R27,_temper+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	STS  _temper,R30
	STS  _temper+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDS  R30,_set_temper_aver
	LDS  R31,_set_temper_aver+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	LDS  R26,_control_action
	LDS  R27,_control_action+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xC:
	LDS  R30,_error
	LDS  R31,_error+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	RCALL __CWD1
	RCALL __CDF1
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xE:
	LDS  R26,_sp
	LDS  R27,_sp+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	STS  _sp,R30
	STS  _sp+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDS  R30,_last_set_temper_aver
	LDS  R31,_last_set_temper_aver+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11:
	LDS  R26,_set_temper_aver
	LDS  R27,_set_temper_aver+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDS  R26,_buzzer_flag
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x13:
	STS  _buzzer_flag,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x14:
	LDI  R26,LOW(13)
	RJMP _send_Uart

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x15:
	LDS  R26,_error
	LDS  R27,_error+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x16:
	RCALL SUBOPT_0x15
	LDI  R30,LOW(65526)
	LDI  R31,HIGH(65526)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x17:
	IN   R30,0x23
	MOV  R26,R30
	LDS  R30,_flow
	LDS  R31,_flow+1
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x18:
	LDS  R30,_temper_min
	LDS  R31,_temper_min+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	RCALL __CDF1U
	__GETD2N 0x3F000000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1A:
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x3F000000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1B:
	LDS  R26,_temper_min
	LDS  R27,_temper_min+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	LDS  R30,_temper_max
	LDS  R31,_temper_max+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1D:
	CLR  R22
	CLR  R23
	RCALL __MULD12U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x400
	RCALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1E:
	STS  _set_temper_aver,R30
	STS  _set_temper_aver+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1F:
	LDS  R26,_reed_switch_time
	LDS  R27,_reed_switch_time+1
	CPI  R26,LOW(0x4669)
	LDI  R30,HIGH(0x4669)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:46 WORDS
SUBOPT_0x20:
	LDS  R26,_reed_switch_time
	LDS  R27,_reed_switch_time+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x21:
	LDS  R26,_flow_min
	LDS  R27,_flow_min+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	STS  _flow,R30
	STS  _flow+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	LDS  R30,_flow_min
	LDS  R31,_flow_min+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	LDS  R30,_last_flow
	LDS  R31,_last_flow+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	LDS  R26,_flow
	LDS  R27,_flow+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(0)
	STS  _reed_switch_time,R30
	STS  _reed_switch_time+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x27:
	RCALL __EQW12
	MOV  R0,R30
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x28:
	RCALL __EQW12
	OR   R0,R30
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x29:
	RCALL __EQW12
	OR   R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	RCALL SUBOPT_0x13
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2B:
	SBI  0x12,6
	LDS  R30,_buzzer_time
	SUBI R30,-LOW(1)
	STS  _buzzer_time,R30
	LDS  R26,_buzzer_time
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2C:
	CBI  0x12,6
	LDI  R30,LOW(2)
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:73 WORDS
SUBOPT_0x2D:
	__GETW1MN _rx_buffer,16
	SBIW R30,48
	MOVW R22,R30
	__GETW1MN _rx_buffer,12
	SBIW R30,48
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL __MULW12U
	__ADDWRR 22,23,30,31
	__GETW1MN _rx_buffer,8
	SBIW R30,48
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2E:
	CBI  0x14,1
	CBI  0x14,2
	LDI  R30,LOW(0)
	STS  _led_pwm_off,R30
	LDS  R30,_led_pwm_on
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__EQW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BREQ __EQW12T
	CLR  R30
__EQW12T:
	RET

__LTW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLO __LTW12UT
	CLR  R30
__LTW12UT:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

;END OF CODE MARKER
__END_OF_CODE:
